<template>
	<view class="content">
		<up-navbar placeholder style="z-index: 10080;">
			<template #left>
				<view class="store-info" @click="navgo('/multipleShop/index/index')">
					<view style="display: flex;font-size: 30rpx;font-weight: bold;">
						{{STORE_INFO.name}}
						<up-icon name="arrow-right"></up-icon>
					</view>
					<view style="display: flex;font-size: 24rpx;color:#777777 ;">
						{{STORE_INFO.detailed_address}}
					</view>
				</view>
			</template>
		</up-navbar>
		<view class="navbar">
			<view style="width: 400rpx;">
				<up-search placeholder="请输入商品" @search="searchKeyword" @clear="searchKeyword" v-model="keyword"
					:showAction="false"></up-search>
			</view>
			<view class="nav-item" @click="navTo('/pages/cart/cart')">
				<image src="@/static/tab/ba.png"></image>
				<text>购物车</text>
			</view>
			<view class="nav-item" @click="navTo('/pagesOrder/order/order?type=0')">
				<image src="@/static/tab/da.png"></image>
				<text>我的订单</text>
			</view>
			<view class="nav-item" @click="navTo('/pages/my/my')">
				<image src="@/static/tab/ca.png"></image>
				<text>个人中心</text>
			</view>
		</view>
		<view class='headScoll' ref='headscroll' :style="{height:isScroll?'0':'200rpx'}">
			<scroll-view class="head-view" scroll-x @scrolltolower="getgoodClassList(0)">
				<view class="list">
					<view class="item" :class="{'item-active': topActive===item.id}"
						v-for="(item, index) in goodClassList" :key="index" @click="changeOne(item, index)">
						<view class="c-img"><up-image height="100rpx" width="100rpx" :src="item.pic"></up-image></view>
						<view class="c-text u-line-1">{{item.name}}</view>
					</view>
					<view class="item" style="width: 80rpx;height: 20rpx;">
					</view>
				</view>
			</scroll-view>
			<view class="r-btn" @click="show=1">
				<view>全</view>
				<view>部</view>
				<up-icon name="list"></up-icon>
			</view>
		</view>
		<viewPopup nav v-if="show===1" @close="show=0">
			<view class="cateOne">
				<view class="head-title">全部分类</view>
				<scroll-view scroll-y style="height: 600rpx;">
					<view class="list">
						<view class="item" :class="{'item-active': topActive===item.id}"
							v-for="(item, index) in goodClassList" :key="index" @click="changeOne(item, index)">
							<view class="c-img"><up-image height="100rpx" width="100rpx" :src="item.pic"></up-image>
							</view>
							<view class="c-text u-line-1">{{item.name}}</view>
						</view>
					</view>
				</scroll-view>
			</view>
		</viewPopup>
		<view class="scroll-box">
			<scroll-view class="left" scroll-y @scrolltolower="getgoodClassList(topActive)">
				<view class="item u-line-1" :class="{'item-active': leftActive===item.id}"
					v-for="(item, index) in goodClassTow" :key="index" @click="changeTwo(item, index)">{{item.name}}
				</view>
				<view style="width: 100%;height: 450rpx;"></view>
			</scroll-view>
			<view class="right">
				<view class="classify">
					<scroll-view style="height: 90rpx;" scroll-x @scrolltolower="getgoodClassList(leftActive)">
						<view class="classify-list">
							<view class="classify-list-item u-line-1" :class="{'item-active': rightActive===item.id}"
								v-for="(item, index) in goodClassThree" :key="index" @click="changeThree(item, index)">
								{{item.name}}
							</view>
							<view style="width: 70rpx;flex-shrink: 0;"></view>
						</view>
					</scroll-view>
					<view class="done" @click="show=2">
						<up-icon name="arrow-down"></up-icon>
					</view>
					<view class="order-by">
						<view class="item" :class="{'order-active': where.order==''}" @click="changeOrder('')">综合</view>
						<view class="item" :class="{'order-active': where.order=='desc'||where.order=='asc'}"
							@click="changeOrder(where.order=='asc'?'desc':'asc')">价格</view>
						<view class="item" :class="{'order-active': where.order=='sales'}"
							@click="changeOrder('sales')">销量</view>
					</view>
				</view>
				<viewPopup v-if="show===2" @close="show=0">
					<view class="cateOne">
						<scroll-view scroll-y style="height: 230rpx;" @scrolltolower="getgoodClassList(leftActive)">
							<view class="classify-list">
								<view class="classify-list-item u-line-1"
									:class="{'item-active': rightActive===item.id}"
									v-for="(item, index) in goodClassThree" :key="index"
									@click="changeThree(item, index)">
									{{item.name}}
								</view>
							</view>
						</scroll-view>
					</view>
				</viewPopup>
				<scroll-view class="list" id='drag_area' style="overscroll-behavior: none;" @scroll="hideHeadView"
					scroll-y @scrolltolower="loadMoreGood">
					<view class="shop-item" v-for="(item, index) in goodList" :key="item.id"
						@click="openGoodPopup(item)">
						<view class="shop-img">
							<up-image width="120rpx" height="120rpx" :src="item.image"></up-image>
						</view>
						<view class="shop-content">
							<view class="title">
								<view class="name u-line-2">{{item.store_name}}</view>
								<view class="tip u-line-1">
									<text>{{item.spec}}</text>
									<!-- <text>{{item.brand_name}}|</text> -->
									<!-- <text>{{item.class_name}}|</text> -->
									<!-- <text>{{item.unit_name}}</text> -->
								</view>
							</view>
							<view class="price-btn">
								<view class="price">￥{{item.price}}</view>
								<view class="btn">
									<u--icon name="plus-circle-fill" size="20" color="#20b128"></u--icon>
								</view>

							</view>
						</view>
					</view>
					<view style="width: 100%;height: 350rpx;"></view>
				</scroll-view>
			</view>
		</view>
		<view class="fiexd-btn-box">
			<view class="price-info">
				<view class="row">
					<view>合计</view>
					<view class="price">¥<text style="font-size: 36rpx;">{{cartInfo.total_price}}</text></view>
				</view>
				<!-- <view class="row">
          <view style="color: #777;">原价 ¥50.00</view>
          <view class="price">优惠 ¥0.00</view>
        </view> -->
			</view>
			<view class="btn">
				<up-button color="#20b128" :disabled="cartInfo.count==0" @click="settleAccounts">结算</up-button>
			</view>
			<view class="cart" @click="navTo('/pages/cart/cart')">
				<image src="@/static/icon/cart.png"></image>
				<view class="badge">{{cartInfo.count}}</view>
			</view>
		</view>

		<goodPopup ref="goodRef" :show="showGoodPopup" @close="showGoodPopup=false" @change="changeGood" />
	</view>
</template>

<script setup>
	import {
		onLoad,
		onShow
	} from "@dcloudio/uni-app"
	import {
		reactive,
		ref,
		onMounted
	} from "vue"
	import {
		goodListApi,
		goodClassListApi
	} from "@/api/good.js"
	import {
		cartCreateApi,
		cartChangeApi,
		cartListApi
	} from "@/api/cart.js";
	import {
		productLogApi,
		userInfoApi
	} from "@/api/user.js";
	import viewPopup from "@/components/viewPopup.vue"
	import goodPopup from "@/components/goodPopup.vue"
	import useCartStore from "@/store/cart.js"
	import {
		getCurrentInstance
	} from 'vue';

	import useUserStore from "@/store/user";
	const userStore = useUserStore();

	const test = () => {
		uni.navigateTo({
			url: '/pageQuota/quotation/index'
		})
	}

	const navgo = (url) => {
		uni.navigateTo({
			url
		})

	}

	//  用户选择的门店信息
	let STORE_INFO = uni.getStorageSync('STORE_INFO');
	if (STORE_INFO)
		STORE_INFO = JSON.parse(STORE_INFO)

	/*商品列表滚动隐藏头部导航 */
	const instance = getCurrentInstance(); // 获取组件实例
	const targetHeight = ref(0)
	const isScroll = ref(false)
	let lastScollTop = 0
	const hideHeadView = (e) => {
		if (e.detail.scrollTop <= 0 || e.detail.scrollTop >= targetHeight.value) return
		isScroll.value = e.detail.scrollTop > lastScollTop
		lastScollTop = e.detail.scrollTop
	}

	/*商品列表滚动隐藏头部导航结束 */
	const cartStore = useCartStore();
	const show = ref(0);
	const topActive = ref(0);
	const changeOne = async (item, index) => {
		console.log(item)
		topActive.value = item.id;
		show.value = 0;
		goodClassTow.value = item?.children || [];
		goodClassThree.value = goodClassTow.value[0]?.children || [];
		leftActive.value = goodClassTow.value[0]?.id || '';
		rightActive.value = goodClassThree.value[0]?.id || '';
		getGoodList();
		if (!item.isLoading && item.id) getgoodClassList(topActive.value, 2); // 判断是否加载过数据, 加载过则不进行加载,节约资源
	}

	const leftActive = ref(0);
	const changeTwo = (item, index) => {
		leftActive.value = item.id;
		show.value = 0;
		goodClassThree.value = item?.children || [];
		rightActive.value = goodClassThree.value[0]?.id || '';
		getGoodList();
		if (!item.isLoading && item.id) getgoodClassList(leftActive.value, 3); // 判断是否加载过数据, 加载过则不进行加载,节约资源
	}

	const rightActive = ref(0);
	const changeThree = (item, index) => {
		rightActive.value = item.id;
		show.value = 0;
		getGoodList();
	}

	const addCart = (product_id, cart_num) => { //加入购物车
		cartCreateApi({
			cart_num: cart_num,
			is_new: 0, // 是否直接购买0否1是
			// goods_id: id,
			store_id: where.value.store_id,
			product_id: product_id
		}).then(res => {
			getCartList();
		}).catch(err => {
			uni.$u.toast(err.msg || '添加失败')
		})
	}

	const keyword = ref('');

	const searchKeyword = () => {
		where.value.name = keyword.value;
		getGoodList();
	}

	const changeOrder = (order) => {
		where.value.order = order;
		getGoodList();
	}

	const where = ref({
		page_no: 1,
		page_size: 25,
		name: '',
		order: '',
		store_id: STORE_INFO.id || ''
	})

	// console.log(JSON.parse(uni.getStorageSync('STORE_INFO')))
	const loading = ref(true);
	const goodList = ref([]);
	const getGoodList = (loadmore = false) => {
		loading.value = true;
		let class_id = rightActive.value || leftActive.value || topActive.value || '';
		let class_all = '';
		// 若分类没有选中时,则直接查询上一级分类
		if (rightActive.value == '') class_all = leftActive.value;
		if (leftActive.value == '') class_all = topActive.value;
		if (topActive.value == '') class_all = '';
		if (class_all) class_id = ""; //只能带其中一个
		if (loadmore) where.value.page_no++;
		else where.value.page_no = 1;
		goodListApi({
			...where.value,
			class_all: class_all,
			class: class_id
		}).then(res => {
			if (loadmore) goodList.value.push(...res.data.lists);
			else goodList.value = res.data.lists;
		})
	}

	// 商品列表触底
	const loadMoreGood = () => {
		console.log('触底了');
		getGoodList(true);
	}

	const goodClassList = ref([]); // 一级分类
	const goodClassTow = ref([]); // 二级分类
	const goodClassThree = ref([]); // 三级分类
	const classMap = new Map();
	const getgoodClassList = (pid = 0, three = 1) => {
		let page_no = classMap.get(pid) || 1;
		// console.log(classMap.get(pid));
		goodClassListApi({
			pid: pid,
			page_no: page_no,
			page_size: 30,
			level: three,
			store_id: STORE_INFO.id || '' // 店铺id，用于获取店铺分类列表，如果为空则获取全部分类列表，否则获取店铺分类列表。
		}).then(res => {
			if (pid == 0) { // 加载一级分类时设置全部分类
				if (!res.data?.lists?.length) return;
				res.data?.lists?.unshift({
					id: "",
					name: "全部",
					pic: "https://lihai001.oss-cn-chengdu.aliyuncs.com/def/35adb202404271727457954.png",
					children: []
				})
				res.data.lists = res.data.lists.map(item => {
					if (!item.children) item.children = [];
					item.children?.unshift({
						id: "",
						pid: item.id, //子分类的全部选项其实就是它本身
						name: "全部",
					})
					item.children = item.children.map(t => {
						if (!t.children) t.children = [];
						t.children?.unshift({
							id: "",
							pid: t.id,
							name: "全部",
						})
						return t;
					})
					return item;
				})
				// 给所有子级分配
				goodClassList.value = [...goodClassList.value, ...res.data?.lists];
				goodClassTow.value = goodClassList.value[0]?.children || [];
				goodClassThree.value = goodClassTow.value[0]?.children || [];
				topActive.value = goodClassList.value[0]?.id;
				leftActive.value = goodClassTow.value[0]?.id;
				rightActive.value = goodClassThree.value[0]?.id;
			} else {
				let flag = 1;
				goodClassList.value.forEach(item => { // 给相应的一级分类添加子菜单
					if (item.id == pid) {
						if (!item.children) {
							item.children = [];
							item.children.unshift({
								id: "",
								pid: item.id,
								name: "全部",
							})
						}
						item.children = [...item.children, ...res.data.lists];
						item.isLoading = true;
						goodClassTow.value = item.children;
						flag = 0;
					}
				})
				if (flag) goodClassTow.value.forEach(item => { //给响应的二级子分类添加菜单
					if (item.id == pid) {
						if (!item.children) {
							item.children = [];
							item.children.unshift({
								id: "",
								pid: item.id,
								name: "全部",
							})
						}
						item.children = [...item.children, ...res.data.lists];
						item.isLoading = true;
						goodClassThree.value = item.children;
					}
				})
			}
			page_no++;
			classMap.set(pid, page_no);
		})
	}

	const navTo = (url) => {
		if (!userStore.token || !userStore.userInfo.mobile) return uni.showModal({
			content: '您需要先登录才可使用该功能, 是否前去登录',
			success: (e) => {
				if (e.confirm) {
					userStore.setToken('');
					userStore.setUserInfo({});
					uni.navigateTo({
						url: '/pages/login/login'
					})
				} else {
					userStore.setToken('');
					userStore.setUserInfo({});
				}
			}
		})
		uni.navigateTo({
			url: url
		})
	}

	// uni.setStorageSync()

	// 选择商品相关
	const showGoodPopup = ref(false);
	const goodRef = ref(null);
	const goodData = ref({});
	const openGoodPopup = (item) => { // 打开数量/重量弹窗
		goodData.value = item;
		goodRef.value.setData(item);
		showGoodPopup.value = true;

		//统计商品的访问记录
		productLogApi({
			product_id: item.product_id,
			cate_id: item.cate_id,
			store_id: STORE_INFO.id || ''
		});
	};
	const changeGood = (data) => { // 确定选择商品重量
		showGoodPopup.value = false;
		if (!userStore.token) return uni.showModal({
			content: '您需要先登录才可使用该功能, 是否前去登录',
			success: (e) => {
				if (e.confirm) {
					userStore.setToken('');
					userStore.setUserInfo({});
					uni.navigateTo({
						url: '/pages/login/login'
					})
				} else {
					userStore.setToken('');
					userStore.setUserInfo({});
				}
			},
		});

		addCart(data.product_id, data.cart_num);
	}
	// 结算
	const settleAccounts = () => {
		uni.navigateTo({
			url: '/pagesOrder/settle/settle'
		})
	}

	// 购物车相关
	const cartInfo = ref({
		total_price: '0.00',
		count: 0
	})
	const getCartList = (res) => {
		cartListApi({
			page_no: 1,
			page_size: 100,
		}).then(res => {
			cartInfo.value = {
				total_price: res.data?.extend?.total_price || '0.00',
				count: res.data?.count || 0
			}
			cartStore.setCartList(res.data?.lists.map(item => item.id))
		})
	}

	onLoad((opt) => {
		if (opt.id) where.value.store_id = opt.id;
		getgoodClassList(0);
		getGoodList();
	})

	onShow(() => {
		// 如果后台变更核销人员权限 可以及时切换
		if (userStore.token && userStore.userInfo.mobile) {
			userInfoApi().then(res => {
				const user = res.data;
				userStore.setUserInfo(user);
				if (user.is_staff == 1) {
					uni.reLaunch({
						url: "/multipleShop/verificationOrder/index"
					})
				} else {
					getCartList();
				}
			});
		}
	});

	onMounted(() => {
		const instance = getCurrentInstance(); // 获取组件实例
		const getWXDom = () => {
			let query = uni.createSelectorQuery().in(instance).select("#drag_area");
			query
				.fields({
						size: true,
						scrollOffset: true,
					},
					(data) => {
						targetHeight.value = data.scrollHeight - data.height
					}
				)
				.exec();
		}
		setTimeout(() => {
			getWXDom()
		}, 500)
	})
</script>

<style lang="scss">
	.content {
		background-color: #fff;
	}

	.navbar {
		padding: 0 20rpx;
		display: flex;
		align-items: center;
		justify-content: space-between;
		font-size: 22rpx;
		color: #777;
		margin-top: 40rpx;

		.nav-item {
			display: flex;
			flex-direction: column;
			align-items: center;
			justify-content: center;

			image {
				height: 40rpx;
				width: 40rpx;
			}
		}
	}

	.head-view {
		background-color: #fff;
		height: 180rpx;
		width: 750rpx;

		.list {
			height: 100%;
			display: flex;
			align-items: center;
			padding: 0 20rpx;
			font-size: 22rpx;

			.item {
				width: 120rpx;
				flex-shrink: 0;
				margin-right: 20rpx;
				display: flex;
				flex-direction: column;
				align-items: center;

				.c-img {
					height: 100rpx;
					width: 100rpx;
					flex-shrink: 0;
					border-radius: 50%;
					border: 2px solid transparent;
					overflow: hidden;
				}

				.c-text {
					width: 100%;
					text-align: center;
					box-sizing: border-box;
					padding: 2rpx 4rpx 3rpx 4rpx;
					border-radius: 50rpx;
					margin-top: 5rpx;
				}
			}

			.item-active {
				.c-img {
					border: 2px solid #20b128;
				}

				.c-text {
					background-color: #20b128;
					color: #fff;
				}
			}
		}
	}

	.r-btn {
		position: absolute;
		right: 0;
		top: 0;
		height: 100%;
		width: 60rpx;
		font-size: 24rpx;
		background-color: #fff;
		display: flex;
		flex-direction: column;
		align-items: center;
		justify-content: center;
		box-shadow: -10rpx 0 60rpx 1rpx rgba(0, 0, 0, 0.3);
	}

	.cateOne {
		background-color: #fff;

		.head-title {
			color: #666666;
			font-size: 30rpx;
			height: 80rpx;
			line-height: 80rpx;
			padding-left: 30rpx;
		}

		.list {
			padding: 20rpx 20rpx;
			font-size: 22rpx;
			display: grid;
			grid-template-columns: repeat(5, 1fr);
			justify-content: center;
			grid-gap: 20rpx;


			.item {
				width: 120rpx;
				margin: 0 auto;
				display: flex;
				flex-direction: column;
				align-items: center;

				.c-img {
					height: 100rpx;
					width: 100rpx;
					flex-shrink: 0;
					border-radius: 50%;
					border: 2px solid transparent;
					overflow: hidden;
				}

				.c-text {
					width: 100%;
					text-align: center;
					box-sizing: border-box;
					padding: 2rpx 4rpx 3rpx 4rpx;
					border-radius: 50rpx;
					margin-top: 5rpx;
				}
			}

			.item-active {
				.c-img {
					border: 2px solid #20b128;
				}

				.c-text {
					background-color: #20b128;
					color: #fff;
				}
			}
		}

		.classify-list {
			padding: 20rpx 30rpx;
			font-size: 22rpx;
			display: grid;
			grid-template-columns: repeat(3, 1fr);
			justify-content: center;
			grid-gap: 20rpx;

			.classify-list-item {
				flex-shrink: 0;
				text-align: center;
				width: 150rpx;
				height: 42rpx;
				line-height: 42rpx;
				background: #F6F6F6;
				border-radius: 22rpx 22rpx 22rpx 22rpx;
				border: 1rpx solid transparent;
			}

			.item-active {
				border: 1rpx solid #20b128;
				color: #20b128;
				background-color: rgba(#20b128, 0.1);
			}
		}
	}

	.scroll-box {
		// background-color: red;
		display: flex;

		.left {
			height: calc(100vh - var(--window-top) - var(--window-bottom) - 300rpx);
			/* #ifdef H5 */
			height: calc(100vh - 44px - 100rpx);
			/* #endif */
			width: 170rpx;
			box-sizing: border-box;
			background-color: #f6f6f6;
			font-size: 24rpx;

			.item {
				height: 96rpx;
				line-height: 96rpx;
				text-align: center;
			}

			.item-active {
				background-color: #fff;
				position: relative;
				color: #20b128;

				&::before {
					content: '';
					background-color: #20b128;
					width: 6rpx;
					height: 48rpx;
					border-radius: 10rpx;
					position: absolute;
					left: 0;
					top: 50%;
					transform: translate(0, -50%);
				}
			}
		}

		.right {
			height: calc(100vh - var(--window-top) - 300rpx);
			/* #ifdef H5 */
			height: calc(100vh - 96px + 20rpx);
			/* #endif */
			width: 580rpx;
			box-sizing: border-box;
			position: relative;
			overflow: hidden;

			.classify {
				height: 150rpx;
				background-color: #fff;
				border-bottom: 1rpx solid #f6f6f6;
				position: relative;
				font-size: 24rpx;

				.classify-list {
					display: flex;
					padding: 20rpx;

					.classify-list-item {
						flex-shrink: 0;
						text-align: center;
						width: 108rpx;
						height: 42rpx;
						line-height: 42rpx;
						background: #F6F6F6;
						border-radius: 22rpx 22rpx 22rpx 22rpx;
						margin-right: 20rpx;
						border: 1rpx solid transparent;
					}

					.item-active {
						border: 1rpx solid #20b128;
						color: #20b128;
						background-color: rgba(#20b128, 0.1);
					}
				}

				.done {
					height: 90rpx;
					width: 60rpx;
					position: absolute;
					top: 0;
					right: 0;
					display: flex;
					justify-content: center;
					align-items: center;
					background-color: #fff;
				}

				.order-by {
					display: flex;
					justify-content: flex-end;
					align-items: center;

					.item {
						padding-right: 20rpx;
					}

					.order-active {
						color: #20b128;
					}
				}
			}

			.list {
				height: calc(100vh - var(--window-top) - 400rpx);
				/* #ifdef H5 */
				height: calc(100vh - 44px - 200rpx);

				/* #endif */
				.shop-item {
					padding: 20rpx;
					border-bottom: 1rpx solid #f6f6f6;
					background-color: #fff;
					display: flex;

					.shop-img {
						height: 120rpx;
						width: 120rpx;
						margin-right: 20rpx;
						border-radius: 14rpx;
						overflow: hidden;
					}

					.shop-content {
						width: 380rpx;
						display: flex;
						flex-direction: column;
						justify-content: space-between;

						.title {
							.name {
								font-size: 28rpx;
							}

							.tip {
								color: #999;
								font-size: 24rpx;
								margin: 2rpx 0;
							}
						}

						.price {
							font-size: 30rpx;
							font-weight: bold;
							color: #F55726;
						}

						.price-btn {
							display: flex;
							justify-content: space-between;

							.btn {
								display: flex;
								align-items: center;

								.num {
									width: 60rpx;
									text-align: center;
								}
							}
						}
					}
				}
			}
		}
	}

	.fiexd-btn-box {
		box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.1);
		height: 140rpx;
		height: calc(constant(safe-area-inset-bottom) + 140rpx);
		/* 适用于iOS设备 */
		height: calc(env(safe-area-inset-bottom) + 140rpx);
		/* 适用于Android设备 */
		padding-top: 40rpx;

		.price-info {
			.row {
				display: flex;
				font-size: 26rpx;
				align-items: center;

				&>view {
					margin-right: 15rpx;
				}

				.price {
					color: #F55726;
				}
			}
		}

		.btn {
			width: 200rpx;
		}

		.cart {
			position: absolute;
			top: -40rpx;
			left: 40rpx;

			image {
				width: 80rpx;
				height: 80rpx;
			}

			.badge {
				position: absolute;
				top: 0;
				right: 0;
				background-color: #F55726;
				color: #fff;
				border-radius: 50%;
				width: 26rpx;
				height: 26rpx;
				text-align: center;
				line-height: 26rpx;
				font-size: 18rpx;
			}
		}
	}

	.headScoll {
		position: relative;
		overflow: hidden;
		transition: 400ms;
	}

	.store-info {
		margin: 0 0 20rpx 20rpx;
		margin-top: 80rpx;
	}
</style>